{-----------------------------------------------------------------------------}
{                                                                             }
{                            Intercom Maintenance                             }
{                                    v1.0                                     }
{                                 Written by                                  }
{                               Steven C. King                                }
{                            stuking@acs.eku.edu                              }
{                            sking@eagle.eku.edu                              }
{                                   (Cujo)                                    }
{                            Copyright 1993, 1994                             }
{                       Last revision: April 15, 1994                         }
{                                                                             }
{                                                                             }
{     This software is licensed for public domain and may be distributed pro- }
{ vided this notice remains intact with each copy distribution.  There is no  }
{ warranty on the performance of this software.  The author assumes no re-    }
{ sponsibility should any damages occur due to code alteration.  Therefore,   }
{ any such consideration of code modification should be reported to the orig- }
{ inal author.                                                                }
{                                                                             }
{      This program will allow the master operator to configure the settings  }
{ of Intercom, remove signon records, and compress the statistics file(auto-  }
{ matically done when removing users).  To compile the program, type the fol- }
{ lowing lines:                                                               }
{                                                                             }
{                    PASCAL/NODEBUG INT_MAINT                                 }
{                    LINK/NODEBUG/NOTRACE/CONTIGUOUS INT_MAINT,CUJ            }
{                                                                             }
{ You must have the CUJ$ routines compiled before attempting the previous     }
{ lines.  For further details on the use of this program, read the documenta- }
{ tion file called INT_MAINT.DOC.  If there are questions, comments, or sug-  }
{ gestions, send e-mail to either address mentioned previously.  Enjoy!       }
{                                                                             }
{ Modifications:                                                              }
{                                                                             }
{-----------------------------------------------------------------------------}

[Optimize(All), Inherit('Sys$Library:Starlet', 'Sys$Library:Pascal$Smg_Routines', 'Sys$Library:Pascal$Lib_Routines', 'Cuj')]

{-----------------------------------------------------------------------------}

PROGRAM Int_Maint(Input, Output);

{-----------------------------------------------------------------------------}

%INCLUDE 'INTERCOM.INC'

{-----------------------------------------------------------------------------}

VAR
  Scr, Dsp,
  Kb        : [Volatile] Unsigned;
  Info      : Setup_Record_Type;
  User      : Cuj$Varying12;
  Sizes     : ARRAY [1..20] OF Integer;
  Fv        : FILE OF Setup_Record_Type;
  Changes,
  Oops      : [Volatile] Cuj$Bit := False;
  Image     : [Volatile] Cuj$Varying255;
  Prot      : [Volatile] Cuj$Uword;

{-----------------------------------------------------------------------------}

VALUE
  Sizes := (12, 38, 38, 4, 4, 4, 4, 4, 4, 12, 12, 12, 2, 2, 10, 10, 10, 10, 10, 10);

{-----------------------------------------------------------------------------}

[Asynchronous]
PROCEDURE Ctrl_Ast;

  VAR
    Outstr : Cuj$Varying50;

  BEGIN
    Smg$Cancel_Input(Kb);
    Smg$Delete_Virtual_Keyboard(Kb);
    Smg$Delete_Pasteboard(Scr);
    Outstr := '';
    IF Oops THEN
      Outstr := ' - channel ranges improperly set';
    Lib$Put_Output(Cuj$Cursor_On+'%'+Image+'-E-ABORT, configuration aborted'+Outstr);
    Cuj$Set_Default_Protection(Prot);
    $Exit;
  END; { Ctrl_Ast }

{-----------------------------------------------------------------------------}

PROCEDURE Make_Screen;

  BEGIN
    Smg$Create_Virtual_Keyboard(Kb);
    Smg$Create_Pasteboard(Scr);
    Writeln(Cuj$Cursor_Off);
    Smg$Set_Out_Of_Band_Asts(Scr, Cuj$Disable_Mask, %IMMED Ctrl_Ast);
    Smg$Begin_Pasteboard_Update(Scr);
    Cuj$Make_Display(Dsp, Scr, 22, 78, 2, 2,,Smg$M_Border, 'Intercom Maintenance v1.0',,,Smg$M_Bold);
    Cuj$Put_String(Dsp, 'Intercom master operator            :', 1, 2);
    Cuj$Put_String(Dsp, 'Location of data files              :', 2, 2);
    Cuj$Put_String(Dsp, 'Introduction data file              :', 3, 2);
    Cuj$Put_String(Dsp, 'Maximum number of signons           :', 4, 2);
    Cuj$Put_String(Dsp, 'Maximum number of operators         :', 5, 2);
    Cuj$Put_String(Dsp, 'Maximum number of ignored users     :', 6, 2);
    Cuj$Put_String(Dsp, 'Maximum number of ignored nicks     :', 7, 2);
    Cuj$Put_String(Dsp, 'Maximum number of users per channel :', 8, 2);
    Cuj$Put_String(Dsp, 'Maximum number of assignments       :', 9, 2);
    Cuj$Put_String(Dsp, 'Range of public channels            :', 10, 2);
    Cuj$Put_String(Dsp, 'Range of private channels           :', 11, 2);
    Cuj$Put_String(Dsp, 'Range of operator channels          :', 12, 2);
    Cuj$Put_String(Dsp, 'Topic change wait in minutes        :', 13, 2);
    Cuj$Put_String(Dsp, 'Nickname change wait in minutes     :', 14, 2);
    Cuj$Put_String(Dsp, 'Channels can be alphanumeric        :', 15, 2);
    Cuj$Put_String(Dsp, 'Announcements by normal operators   :', 16, 2);
    Cuj$Put_String(Dsp, 'Operators can make/remove other ops :', 17, 2);
    Cuj$Put_String(Dsp, 'Normal users can spawn out          :', 18, 2);
    Cuj$Put_String(Dsp, 'Users have access to SEND           :', 19, 2);
    Cuj$Put_String(Dsp, 'Operation hours are in effect       :', 20, 2);
    Cuj$Put_String(Dsp, 'Use the arrow keys or keypad to move the highlighter - RETURN to select', 21,,Smg$M_Bold, Cuj$C_Center_Column);
    Cuj$Put_String(Dsp, 'Hit R to redraw - T to set operation hours - Q or Ctrl_Z to quit', 22,,Smg$M_Bold, Cuj$C_Center_Column);
    Smg$End_Pasteboard_Update(Scr);
  END; { Make_Screen }

{-----------------------------------------------------------------------------}

FUNCTION Get_Uic : Cuj$Varying8;

  VAR
    Grp, Mem : Unsigned;

  BEGIN
    Lib$Getjpi(Jpi$_Grp,,,%REF Grp);
    Lib$Getjpi(Jpi$_Mem,,,%REF Mem);
    Get_Uic := '[' + Oct(Grp, 3) + Oct(Mem, 3) + ']';
  END; { Get_Uic }

{-----------------------------------------------------------------------------}

PROCEDURE Get_Info;

  VAR
    X, Y, Z  : Integer;
    Dur      : Unsigned;
    Key      : Cuj$Uword;
    Dir, Fnm : Cuj$Varying255;

  BEGIN
    Image := Cuj$Element(Cuj$Get_Image_Name(Cuj$C_Filename), '.');
    Dir := Cuj$Get_Image_Name(Cuj$C_Directory);
    Fnm := Dir + Config_Name;
    Lib$Getjpi(Jpi$_Username,,,,User.Body, User.Length);
    User := Cuj$Edit(User, Cuj$C_Trim);
    Cuj$Set_Default_Protection(Prot_Mask, Prot);
    Open(Fv, Fnm, Unknown, Access_Method := Direct, Error := Continue);
    IF Status(Fv) <> 0 THEN
      REPEAT
        Smg$Begin_Pasteboard_Update(Scr);
        Cuj$Make_Display(Dur, Scr, 4, 44,,,Smg$M_Reverse, Smg$M_Border, '*** ERROR ***',,,Smg$M_Bold, Cuj$C_Center);
        Smg$Ring_Bell(Dur, 3);
        IF Status(Fv) = 1 THEN
          Cuj$Put_String(Dur, 'Intercom is being configured', 2,,,Cuj$C_Center_Column)
        ELSE
          BEGIN
            Cuj$Put_String(Dur, 'Configuration file is corrupt, or there', 2,,,Cuj$C_Center_Column);
            Cuj$Put_String(Dur, 'are users signed onto Intercom', 3,,,Cuj$C_Center_Column);
          END;
        Cuj$Put_String(Dur, 'Hit Q to quit - any other key to try again', 4,,Smg$M_Bold, Cuj$C_Center_Column);
        Smg$End_Pasteboard_Update(Scr);
        Smg$Read_Keystroke(Kb, Key);
        Smg$Delete_Virtual_Display(Dur);
        IF Key IN [97..122] THEN
          Key := Key - 32;
        Open(Fv, Fnm, Unknown, Access_Method := Direct, Error := Continue);
      UNTIL (Status(Fv) = 0) OR (Key IN [Cuj$Upcase_Q, Cuj$Ctrl_Z]);
    IF Key IN [Cuj$Upcase_Q, Cuj$Ctrl_Z] THEN
      Ctrl_Ast;
    Reset(Fv);
    IF Eof(Fv) THEN
      BEGIN
        Rewrite(Fv);
        Info.Master_Operator := 'STUKING';
        Info.Master_Uic := Get_Uic;
        Info.Data_Directory := Dir;
        Info.Intro_Filename := 'INT$INTRO.DAT';
        Info.Max_Users := 0;
        Info.Current_Signons := 0;
        Info.Max_Operators := 0;
        Info.Max_User_Ignore := 0;
        Info.Max_Nick_Ignore := 0;
        Info.Max_Per_Channel := 0;
        Info.Max_Assigns := 0;
        Info.Public_Channels.Low := 0;
        Info.Public_Channels.High := 500;
        Info.Private_Channels.Low := 501;
        Info.Private_Channels.High := 1000;
        Info.Operator_Channels.Low := -1000;
        Info.Operator_Channels.High := -1;
        Info.Topic_Wait := 5;
        Info.Nickname_Wait := 5;
        Info.Shutdown := False;
        Info.Alphanumeric := False;
        Info.Allow_Announce := False;
        Info.Allow_Op_Access := False;
        Info.Allow_Spawn := True;
        Info.Allow_Send := True;
        Info.Hours_In_Effect := False;
        FOR Z := 1 TO 7 DO
          FOR Y := 0 TO 23 DO
            FOR X := 1 TO 4 DO
              Info.Operation_Hours[Z,Y,X] := '-';
        Cuj$Change_Text(Info.Master_Operator, Int$Keyword);
        Cuj$Change_Text(Info.Master_Uic, Int$Keyword);
        Cuj$Change_Text(Info.Data_Directory, Int$Keyword);
        Cuj$Change_Text(Info.Intro_Filename, Int$Keyword);
        Fv^ := Info;
        Put(Fv);
      END
    ELSE
      Info := Fv^;
  END; { Get_Info }

{-----------------------------------------------------------------------------}

PROCEDURE Display_Info;

  VAR
    Errdsp : Unsigned;
    Key    : Cuj$Uword;
    Option : Cuj$Varying2;

  BEGIN
    Lib$Get_Foreign(Option.Body,,Option.Length);
    Cuj$Change_Text(Info.Master_Operator, Int$Keyword, Cuj$C_Decrypt);
    Cuj$Change_Text(Info.Master_Uic, Int$Keyword, Cuj$C_Decrypt);
    Cuj$Change_Text(Info.Data_Directory, Int$Keyword, Cuj$C_Decrypt);
    Cuj$Change_Text(Info.Intro_Filename, Int$Keyword, Cuj$C_Decrypt);
    IF (User = Info.Master_Operator) OR (Option = '-B') AND (Get_Uic = Info.Master_Uic) THEN
      BEGIN
        Cuj$Put_String(Dsp, Info.Master_Operator, 1, 40, Smg$M_Bold);
        Cuj$Put_String(Dsp, Cuj$Substr(Info.Data_Directory, 1, 38), 2, 40, Smg$M_Bold);
        Cuj$Put_String(Dsp, Cuj$Substr(Info.Intro_Filename, 1, 38), 3, 40, Smg$M_Bold);
        Cuj$Put_String(Dsp, Cuj$String(Info.Max_Users), 4, 40, Smg$M_Bold);
        Cuj$Put_String(Dsp, Cuj$String(Info.Max_Operators), 5, 40, Smg$M_Bold);
        Cuj$Put_String(Dsp, Cuj$String(Info.Max_User_Ignore), 6, 40, Smg$M_Bold);
        Cuj$Put_String(Dsp, Cuj$String(Info.Max_Nick_Ignore), 7, 40, Smg$M_Bold);
        Cuj$Put_String(Dsp, Cuj$String(Info.Max_Per_Channel), 8, 40, Smg$M_Bold);
        Cuj$Put_String(Dsp, Cuj$String(Info.Max_Assigns), 9, 40, Smg$M_Bold);
        Cuj$Put_String(Dsp, Cuj$String(Info.Public_Channels.Low)+'..'+Cuj$String(Info.Public_Channels.High), 10, 40, Smg$M_Bold);
        Cuj$Put_String(Dsp, Cuj$String(Info.Private_Channels.Low)+'..'+Cuj$String(Info.Private_Channels.High), 11, 40, Smg$M_Bold);
        Cuj$Put_String(Dsp, Cuj$String(Info.Operator_Channels.Low)+'..'+Cuj$String(Info.Operator_Channels.High), 12, 40, Smg$M_Bold);
        Cuj$Put_String(Dsp, Cuj$String(Info.Topic_Wait), 13, 40, Smg$M_Bold);
        Cuj$Put_String(Dsp, Cuj$String(Info.Nickname_Wait), 14, 40, Smg$M_Bold);
        IF Info.Alphanumeric THEN
          Cuj$Put_String(Dsp, 'YES', 15, 40, Smg$M_Bold)
        ELSE
          Cuj$Put_String(Dsp, 'NO', 15, 40, Smg$M_Bold);
        IF Info.Allow_Announce THEN
          Cuj$Put_String(Dsp, 'YES', 16, 40, Smg$M_Bold)
        ELSE
          Cuj$Put_String(Dsp, 'NO', 16, 40, Smg$M_Bold);
        IF Info.Allow_Op_Access THEN
          Cuj$Put_String(Dsp, 'YES', 17, 40, Smg$M_Bold)
        ELSE
          Cuj$Put_String(Dsp, 'NO', 17, 40, Smg$M_Bold);
        IF Info.Allow_Spawn THEN
          Cuj$Put_String(Dsp, 'YES', 18, 40, Smg$M_Bold)
        ELSE
          Cuj$Put_String(Dsp, 'NO', 18, 40, Smg$M_Bold);
        IF Info.Allow_Send THEN
          Cuj$Put_String(Dsp, 'YES', 19, 40, Smg$M_Bold)
        ELSE
          Cuj$Put_String(Dsp, 'NO', 19, 40, Smg$M_Bold);
        IF Info.Hours_In_Effect THEN
          Cuj$Put_String(Dsp, 'YES', 20, 40, Smg$M_Bold)
        ELSE
          Cuj$Put_String(Dsp, 'NO', 20, 40, Smg$M_Bold);
      END
    ELSE
      BEGIN
        Smg$Begin_Pasteboard_Update(Scr);
        Cuj$Make_Display(Errdsp, Scr, 5, 49,,,Smg$M_Reverse, Smg$M_Border, '*** ERROR ***',,,Smg$M_Bold, Cuj$C_Center);
        Smg$Ring_Bell(Errdsp, 3);
        Cuj$Put_String(Errdsp, 'Only the master operator can configure Intercom', 2,,,Cuj$C_Center_Column);
        Cuj$Put_String(Errdsp, 'Contact '+Info.Master_Operator+' for setting changes', 3,,,Cuj$C_Center_Column);
        Cuj$Put_String(Errdsp, 'Hit any key to exit', 4,,,Cuj$C_Center_Column);
        Smg$End_Pasteboard_Update(Scr);
        Smg$Read_Keystroke(Kb, Key);
        Writeln(Cuj$Cursor_On);
        Smg$Delete_Pasteboard(Scr);
        Cuj$Set_Default_Protection(Prot);
        $Exit;
      END;
  END; { Display_Info }

{-----------------------------------------------------------------------------}

PROCEDURE Modify_Info;

  VAR
    Key, Keywd : Cuj$Uword;
    Temp,
    Str        : Cuj$Varying255;
    X          : Integer;
    Attribute,
    Inp, Err   : Unsigned;
    Range      : ARRAY [1..2] OF Integer;
    Buf        : ARRAY [1..20] OF Cuj$Varying255;
    Lim        : SET OF Char;
    Opt        : ARRAY [1..2] OF Cuj$Varying3;
    Res        : Cuj$Varying3;
    Change1,
    Change2,
    Change3    : Cuj$Bit := False;

  PROCEDURE Add_To_Buffer(String : VARYING [$Len] OF Char);

    VAR
      Idx : Integer;

    BEGIN
      FOR Idx := 20 DOWNTO 2 DO
        Buf[Idx] := Buf[Idx-1];
      Buf[1] := String;
    END; { Add_To_Buffer }

  PROCEDURE Operation_Times;

    VAR
      Rend,
      Rend2,
      Outdsp,
      Oopsdsp,
      Timedsp  : Unsigned;
      Old_I,
      Old_J,
      M, I, J,
      K, Old_K : Integer;
      Word     : Cuj$Uword;
      Closed   : Cuj$Bit := True;
      Days     : [Static] ARRAY [1..7] OF Cuj$Varying9 VALUE [ 1 : 'Sunday';
                                                               2 : 'Monday';
                                                               3 : 'Tuesday';
                                                               4 : 'Wednesday';
                                                               5 : 'Thursday';
                                                               6 : 'Friday';
                                                               7 : 'Saturday' ];
      Setting  : [Static] PACKED ARRAY [1..4,1..2] OF Char VALUE [ 1 : 'XX';
                                                                   2 : '-X';
                                                                   3 : 'X-';
                                                                   4 : '--' ];

    BEGIN
      Smg$End_Pasteboard_Update(Scr);
      Smg$Unpaste_Virtual_Display(Dsp, Scr);
      Smg$Begin_Pasteboard_Update(Scr);
      Cuj$Make_Display(Timedsp, Scr, 23, 120);
      Cuj$Make_Display(Outdsp, Scr, 1, 80, 24);
      Cuj$Put_String(Timedsp, 'Day of the Week',,2);
      Smg$Draw_Line(Timedsp, 2, 2, 2, 16);
      Smg$Draw_Line(Timedsp, 2, 18, 2, 114);
      FOR I := 1 TO 7 DO
        BEGIN
          Cuj$Put_String(Timedsp, Days[I], I*3, 2);
          Cuj$Put_String(Timedsp, 'am', I*3, 14);
          Cuj$Put_String(Timedsp, 'pm', I*3+1, 14);
          Smg$Draw_Line(Timedsp, I*3+2, 2, I*3+2, 16);
          Smg$Draw_Line(Timedsp, I*3+2, 18, I*3+2, 114);
        END;
      I := 18;
      J := 12;
      REPEAT
        Smg$Draw_Line(Timedsp, 2, I, 23, I);
        IF I MOD 8 = 2 THEN
          BEGIN
            IF I < 114 THEN
              Cuj$Put_String(Timedsp, Cuj$String(J),,I);
            J := J + 1;
            IF J = 13 THEN
              J := 1;
          END;
        I := I + 2;
      UNTIL I > 114;
      Smg$Change_Rendition(Timedsp, 1, 17, 23, 1, Smg$M_Reverse);
      Cuj$Put_String(Outdsp, 'Arrows or keypad - selector  RETURN - toggle  R - redraw  Q or Ctrl_Z - quit',,,Smg$M_Bold, Cuj$C_Center);
      Smg$Create_Viewport(Timedsp, 1, 1, 23, 80);
      FOR I := 1 TO 7 DO
        FOR J := 0 TO 11 DO
          FOR K := 1 TO 4 DO
            BEGIN
              Rend := Smg$M_Normal;
              Rend2 := Smg$M_Normal;
              IF Info.Operation_Hours[I,J,K] = 'X' THEN
                Rend := Smg$M_Bold;
              IF Info.Operation_Hours[I,J+12,K] = 'X' THEN
                Rend2 := Smg$M_Bold;
              Cuj$Put_String(Timedsp, Info.Operation_Hours[I,J,K], I*3, (19+(J*8))+((K-1)*2), Rend);
              Cuj$Put_String(Timedsp, Info.Operation_Hours[I,J+12,K], (I*3)+1, (19+(J*8))+((K-1)*2), Rend2);
            END;
      Cuj$Put_String(Timedsp, Info.Operation_Hours[1,0,1], 3, 19, Smg$M_Reverse);
      Cuj$Put_String(Timedsp, Info.Operation_Hours[1,12,1], 4, 19, Smg$M_Reverse);
      Smg$Change_Rendition(Timedsp, 1, 18, 1, 2, Smg$M_Bold);
      Smg$Change_Rendition(Timedsp, 3, 1, 2, 16, Smg$M_Bold);
      Smg$End_Pasteboard_Update(Scr);
      I := 1;
      J := 0;
      K := 1;
      Old_K := 0;
      M := 1;
      REPEAT
        Smg$Read_Keystroke(Kb, Word);
        Rend := Smg$M_Normal;
        Rend2 := Smg$M_Normal;
        IF Info.Operation_Hours[I,J,K] = 'X' THEN
          Rend := Smg$M_Bold;
        IF Info.Operation_Hours[I,J+12,K] = 'X' THEN
          Rend2 := Smg$M_Bold;
        IF Word IN [97..122] THEN
          Word := Word - 32;
        IF (Word <> Cuj$Upcase_Q) AND (Word <> Cuj$Ctrl_Z) THEN
          BEGIN
            Cuj$Put_String(Timedsp, Info.Operation_Hours[I,J,K], I*3, (19+(J*8))+((K-1)*2), Rend);
            Cuj$Put_String(Timedsp, Info.Operation_Hours[I,J+12,K], (I*3)+1, (19+(J*8))+((K-1)*2), Rend2);
          END;
        CASE Word OF
          Cuj$Upcase_R             : Smg$Repaint_Screen(Scr);
          Cuj$Left_Arrow, Cuj$Kp4  : IF K = 1 THEN
                                       BEGIN
                                         Smg$Change_Rendition(Timedsp, 1, (19+(J*8))-1, 1, 2);
                                         K := 4;
                                         IF J = 0 THEN
                                           BEGIN
                                             J := 11;
                                             Smg$Scroll_Viewport(Timedsp, Smg$M_Left, 34);
                                           END
                                         ELSE
                                           J := J - 1;
                                         Smg$Change_Rendition(Timedsp, 1, (19+(J*8))-1, 1, 2, Smg$M_Bold);
                                       END
                                     ELSE
                                       BEGIN
                                         IF (J = 7) AND (K = 4) THEN
                                           Smg$Scroll_Viewport(Timedsp, Smg$M_Right, 34);
                                         K := K - 1;
                                       END;
          Cuj$Right_Arrow, Cuj$Kp6 : IF K = 4 THEN
                                       BEGIN
                                         Smg$Change_Rendition(Timedsp, 1, (19+(J*8))-1, 1, 2);
                                         K := 1;
                                         IF J = 11 THEN
                                           BEGIN
                                             J := 0;
                                             Smg$Scroll_Viewport(Timedsp, Smg$M_Right, 34);
                                           END
                                         ELSE
                                           J := J + 1;
                                         Smg$Change_Rendition(Timedsp, 1, (19+(J*8))-1, 1, 2, Smg$M_Bold);
                                       END
                                     ELSE
                                       BEGIN
                                         IF (J = 7) AND (K = 3) THEN
                                           Smg$Scroll_Viewport(Timedsp, Smg$M_Left, 34);
                                         K := K + 1;
                                       END;
          Cuj$Up_Arrow, Cuj$Kp8    : BEGIN
                                       Smg$Change_Rendition(Timedsp, I*3, 1, 2, 16);
                                       IF I = 1 THEN
                                         I := 7
                                       ELSE
                                         I := I - 1;
                                       Smg$Change_Rendition(Timedsp, I*3, 1, 2, 16, Smg$M_Bold);
                                     END;
          Cuj$Down_Arrow, Cuj$Kp2  : BEGIN
                                       Smg$Change_Rendition(Timedsp, I*3, 1, 2, 16);
                                       IF I = 7 THEN
                                         I := 1
                                       ELSE
                                         I := I + 1;
                                       Smg$Change_Rendition(Timedsp, I*3, 1, 2, 16, Smg$M_Bold);
                                     END;
          Cuj$Space, Cuj$Return,
          Cuj$Enter                : BEGIN
                                       Changes := True;
                                       IF Old_K = K THEN
                                         BEGIN
                                           M := M + 1;
                                           IF M = 5 THEN
                                             M := 1;
                                         END
                                       ELSE
                                         Old_K := K;
                                       Info.Operation_Hours[I,J,K] := Setting[M,1];
                                       Info.Operation_Hours[I,J+12,K] := Setting[M,2];
                                     END;
        END;
        IF (Word = Cuj$Upcase_Q) OR (Word = Cuj$Ctrl_Z) THEN
          BEGIN
            Old_I := I;
            Old_K := K;
            Old_J := J;
            FOR I := 1 TO 7 DO
              FOR J := 0 TO 23 DO
                FOR K := 1 TO 4 DO
                  IF Closed THEN
                    Closed := Info.Operation_Hours[I,J,K] = 'X';
            I := Old_I;
            J := Old_J;
            K := Old_K;
            IF Closed THEN
              BEGIN
                Smg$Begin_Pasteboard_Update(Scr);
                Cuj$Make_Display(Oopsdsp, Scr, 5, 29,,,Smg$M_Reverse, Smg$M_Border, '*** ERROR ***',,,Smg$M_Bold, Cuj$C_Center);
                Cuj$Put_String(Oopsdsp, 'Intercom must have at least', 2,,,Cuj$C_Center_Column);
                Cuj$Put_String(Oopsdsp, 'fifteen minutes open', 3,,,Cuj$C_Center_Column);
                Cuj$Put_String(Oopsdsp, 'Hit any key to continue', 4,,,Cuj$C_Center_Column);
                Smg$End_Pasteboard_Update(Scr);
                Smg$Read_Keystroke(Kb, Word);
                Smg$Delete_Virtual_Display(Oopsdsp);
                Word := 0;
              END;
          END
        ELSE
          BEGIN
            Cuj$Put_String(Timedsp, Info.Operation_Hours[I,J,K], I*3, (19+(J*8))+((K-1)*2), Smg$M_Reverse);
            Cuj$Put_String(Timedsp, Info.Operation_Hours[I,J+12,K], (I*3)+1, (19+(J*8))+((K-1)*2), Smg$M_Reverse);
          END;
      UNTIL (Word = Cuj$Ctrl_Z) OR (Word = Cuj$Upcase_Q);
      Smg$Delete_Virtual_Display(Timedsp);
      Smg$Delete_Virtual_Display(Outdsp);
      Smg$Paste_Virtual_Display(Dsp, Scr, 2, 2);
    END; { Operation_Times }

  FUNCTION Channels_Ok : Cuj$Bit;

    VAR
      Ranges_Ok, Chk1, Chk2, Chk3, Chk4, Chk5, Chk6 : Cuj$Bit;

    BEGIN
          (* Check to see if the ranges of the channels are fine *)
      Ranges_Ok := (Info.Operator_Channels.Low <= Info.Operator_Channels.High) AND
                   (Info.Public_Channels.Low <= Info.Public_Channels.High) AND
                   (Info.Private_Channels.Low <= Info.Private_Channels.High);

              (* Checking in order of public-private-operator *)
      Chk1 := (Info.Public_Channels.High = Info.Private_Channels.Low - 1) AND
              (Info.Private_Channels.High = Info.Operator_Channels.Low - 1);

              (* Checking in order of public-operator-private *)
      Chk2 := (Info.Public_Channels.High = Info.Operator_Channels.Low - 1) AND
              (Info.Operator_Channels.High = Info.Private_Channels.Low - 1);

              (* Checking in order of private-public-operator *)
      Chk3 := (Info.Private_Channels.High = Info.Public_Channels.Low - 1) AND
              (Info.Public_Channels.High = Info.Operator_Channels.Low - 1);

              (* Checking in order of private-operator-public *)
      Chk4 := (Info.Private_Channels.High = Info.Operator_Channels.Low - 1) AND
              (Info.Operator_Channels.High = Info.Public_Channels.Low - 1);

              (* Checking in order of operator-public-private *)
      Chk5 := (Info.Operator_Channels.High = Info.Public_Channels.Low - 1) AND
              (Info.Public_Channels.High = Info.Private_Channels.Low - 1);

              (* Checking in order of operator-private-public *)
      Chk6 := (Info.Operator_Channels.High = Info.Private_Channels.Low - 1) AND
              (Info.Private_Channels.High = Info.Public_Channels.Low - 1);

(* True if the ranges are fine and channels do not exceed predefined limits *)
      Channels_Ok := Ranges_Ok AND
                     (Chk1 OR Chk2 OR Chk3 OR Chk4 OR Chk5 OR Chk6);
    END; { Channels_Ok }

  BEGIN
    Opt[1] := 'YES';
    Opt[2] := 'NO';
    FOR X := 1 TO 20 DO
      Buf[X] := '';
    X := 1;
    Range[1] := 1;
    Range[2] := 1;
    Smg$Change_Rendition(Dsp, X, 40, 1, Sizes[X], Smg$M_Reverse);
    REPEAT
      Smg$Read_Keystroke(Kb, Key);
      IF Key IN [97..122] THEN
        Key := Key - 32;
      Smg$Begin_Pasteboard_Update(Scr);
      IF NOT(Key IN [Cuj$Return, Cuj$Space, Cuj$Upcase_T]) THEN
        Smg$Change_Rendition(Dsp, X, 40, 1, Sizes[X], Smg$M_Bold);
      CASE Key OF
        Cuj$Upcase_R             : Smg$Repaint_Screen(Scr);
        Cuj$Upcase_T             : Operation_Times;
        Cuj$Up_Arrow, Cuj$Kp8    : BEGIN
                                     X := X - 1;
                                     IF X = 0 THEN
                                       X := 20;
                                   END;
        Cuj$Down_Arrow, Cuj$Kp2  : BEGIN
                                     X := X + 1;
                                     IF X = 21 THEN
                                       X := 1;
                                   END;
        Cuj$Right_Arrow, Cuj$Kp6 : CASE X OF
                                     2 : IF (Info.Data_Directory.Length > 38) AND
                                            (38 + Range[1] <= Info.Data_Directory.Length) THEN
                                           BEGIN
                                             Range[1] := Range[1] + 1;
                                             Cuj$Put_String(Dsp, Cuj$Substr(Info.Data_Directory, Range[1], 38), 2, 40);
                                           END;
                                     3 : IF (Info.Intro_Filename.Length > 38) AND
                                            (38 + Range[2] <= Info.Intro_Filename.Length) THEN
                                           BEGIN
                                             Range[2] := Range[2] + 1;
                                             Cuj$Put_String(Dsp, Cuj$Substr(Info.Intro_Filename, Range[2], 38), 3, 40);
                                           END;
                                   END;
        Cuj$Left_Arrow, Cuj$Kp4  : CASE X OF
                                     2 : IF Range[1] > 1 THEN
                                           BEGIN
                                             Range[1] := Range[1] - 1;
                                             Cuj$Put_String(Dsp, Cuj$Substr(Info.Data_Directory, Range[1], 38), 2, 40);
                                           END;
                                     3 : IF Range[2] > 1 THEN
                                           BEGIN
                                             Range[2] := Range[2] - 1;
                                             Cuj$Put_String(Dsp, Cuj$Substr(Info.Intro_Filename, Range[2], 38), 3, 40);
                                           END;
                                   END;
        Cuj$Return, Cuj$Enter,
        Cuj$Space                : BEGIN
                                     Smg$End_Pasteboard_Update(Scr);
                                     Writeln(Cuj$Cursor_On);
                                     Cuj$Make_Display(Inp, Scr, 1, Sizes[X], X+1, 41, Smg$M_Bold+Smg$M_Reverse+Smg$M_Blink);
                                     Attribute := Cuj$C_Normal;
                                     CASE X OF
                                       1            : Lim := ['A'..'Z', 'a'..'z', '0'..'9', '_', '-', '$'];
                                       2, 3         : BEGIN
                                                       Lim := ['A'..'Z', 'a'..'z', '0'..'9', '-', '_', ';', ':', '[', ']', '$', '.'];
                                                       Attribute := Cuj$C_Exceed;
                                                      END;
                                       4, 5, 6, 7,
                                       8, 9, 13, 14 : Lim := ['0'..'9'];
                                       10, 11, 12   : Lim := ['0'..'9', '.', '-'];
                                     END;
                                     IF X IN [15..20] THEN
                                       BEGIN
                                         Cuj$Get_Option(Inp, Kb,,,Chr(0), Opt, Res,,,,,,,,,Cuj$C_Upcase);
                                         Add_To_Buffer(Res);
                                       END
                                     ELSE
                                       BEGIN
                                         Cuj$Get_String(Inp, Kb,,Str, Buf, Sizes[X],,,,Keywd, Lim, Cuj$C_Upcase+Attribute);
                                         IF Str.Length > 0 THEN
                                           Add_To_Buffer(Str);
                                       END;
                                     IF (Str.Length > 0) OR (X IN [15..20]) THEN
                                       BEGIN
                                         Changes := True;
                                         Temp := Cuj$Omit(Str, '.');
                                         CASE X OF
                                           1  : Info.Master_Operator := Str;
                                           2  : BEGIN
                                                  Info.Data_Directory := Str;
                                                  Range[1] := 1;
                                                END;
                                           3  : BEGIN
                                                  Info.Intro_Filename := Str;
                                                  Range[2] := 1;
                                                END;
                                           4  : Info.Max_Users := Cuj$Integer(Str);
                                           5  : Info.Max_Operators := Cuj$Integer(Str);
                                           6  : Info.Max_User_Ignore := Cuj$Integer(Str);
                                           7  : Info.Max_Nick_Ignore := Cuj$Integer(Str);
                                           8  : Info.Max_Per_Channel := Cuj$Integer(Str);
                                           9  : Info.Max_Assigns := Cuj$Integer(Str);
                                           10 : BEGIN
                                                  Change1 := True;
                                                  Info.Public_Channels.Low := Cuj$Integer(Cuj$Element(Temp, '.'));
                                                  Info.Public_Channels.High := Cuj$Integer(Cuj$Element(Temp, '.', 1));
                                                  Str := Cuj$String(Info.Public_Channels.Low) + '..' + Cuj$String(Info.Public_Channels.High);
                                                  Buf[X] := Str;
                                                END;
                                           11 : BEGIN
                                                  Change2 := True;
                                                  Info.Private_Channels.Low := Cuj$Integer(Cuj$Element(Temp, '.'));
                                                  Info.Private_Channels.High := Cuj$Integer(Cuj$Element(Temp, '.', 1));
                                                  Str := Cuj$String(Info.Private_Channels.Low) + '..' + Cuj$String(Info.Private_Channels.High);
                                                  Buf[X] := Str;
                                                END;
                                           12 : BEGIN
                                                  Change3 := True;
                                                  Info.Operator_Channels.Low := Cuj$Integer(Cuj$Element(Temp, '.'));
                                                  Info.Operator_Channels.High := Cuj$Integer(Cuj$Element(Temp, '.', 1));
                                                  Str := Cuj$String(Info.Operator_Channels.Low) + '..' + Cuj$String(Info.Operator_Channels.High);
                                                  Buf[X] := Str;
                                                END;
                                           13 : Info.Topic_Wait := Cuj$Integer(Str);
                                           14 : Info.Nickname_Wait := Cuj$Integer(Str);
                                           15 : Info.Alphanumeric := Res = 'YES';
                                           16 : Info.Allow_Announce := Res = 'YES';
                                           17 : Info.Allow_Op_Access := Res = 'YES';
                                           18 : Info.Allow_Spawn := Res = 'YES';
                                           19 : Info.Allow_Send := Res = 'YES';
                                           20 : Info.Hours_In_Effect := Res = 'YES';
                                         END;
                                         IF X IN [4..9, 13, 14] THEN
                                           Str := Cuj$String(Cuj$Integer(Str)); (* Gets rid of leading zeros *)
                                         Smg$Erase_Display(Dsp, X, 40, X, 40+Sizes[X]-1);
                                         IF X IN [15..20] THEN
                                           Cuj$Put_String(Dsp, Res, X, 40)
                                         ELSE
                                           IF X IN [10..12] THEN
                                             Cuj$Put_String(Dsp, Cuj$Substr(Str, 1, 12), X, 40)
                                           ELSE
                                             Cuj$Put_String(Dsp, Cuj$Substr(Str, 1, 38), X, 40);
                                         Smg$Change_Rendition(Dsp, X, 40, 1, Sizes[X], Smg$M_Reverse);
                                       END;
                                     Writeln(Cuj$Cursor_Off);
                                     Smg$Delete_Virtual_Display(Inp);
                                   END;
      END;
      IF NOT(Key IN [Cuj$Return, Cuj$Space, Cuj$Upcase_T]) THEN
        Smg$Change_Rendition(Dsp, X, 40, 1, Sizes[X], Smg$M_Reverse);
      Smg$End_Pasteboard_Update(Scr);
      IF Change1 AND Change2 AND Change3 THEN
        BEGIN
          Change1 := False;
          Change2 := False;
          Change3 := False;
          IF NOT(Channels_Ok) THEN
            BEGIN
              Smg$Begin_Pasteboard_Update(Scr);
              Cuj$Make_Display(Err, Scr, 4, 53,,,Smg$M_Reverse, Smg$M_Border, '*** ERROR ***',,,Smg$M_Bold, Cuj$C_Center);
              Smg$Ring_Bell(Err, 3);
              Cuj$Put_String(Err, 'Channels improperly set - changes will not be saved', 2,,,Cuj$C_Center_Column);
              Cuj$Put_String(Err, 'Hit Q or Ctrl_Z to quit - any other key to repair', 3,,,Cuj$C_Center_Column);
              Smg$End_Pasteboard_Update(Scr);
              Smg$Read_Keystroke(Kb, Key);
              Smg$Delete_Virtual_Display(Err);
            END;
        END;
    UNTIL Key IN [Cuj$Upcase_Q, Cuj$Ctrl_Z];
    IF NOT(Channels_Ok) THEN
      BEGIN
        Oops := True;
        Ctrl_Ast;
      END;
  END; { Modify_Info }

{-----------------------------------------------------------------------------}

PROCEDURE Save_Info;

  VAR
    Err     : Unsigned;
    Key     : Cuj$Uword;
    User_Fv : FILE OF User_Record_Type;
    Chan_Fv : FILE OF Chan_Record_Type;
    Stat_Fv : FILE OF Stat_Record_Type;

  BEGIN
    Reset(Fv, Error := Continue);
    Fv^ := Info;
    Cuj$Change_Text(Fv^.Master_Operator, Int$Keyword);
    Cuj$Change_Text(Fv^.Master_Uic, Int$Keyword);
    Cuj$Change_Text(Fv^.Data_Directory, Int$Keyword);
    Cuj$Change_Text(Fv^.Intro_Filename, Int$Keyword);
    Update(Fv, Error := Continue);
    IF (Status(Fv) <> 0) THEN
      BEGIN
        Changes := False;
        Smg$Begin_Pasteboard_Update(Scr);
        Cuj$Make_Display(Err, Scr, 4, 44,,,Smg$M_Reverse, Smg$M_Border, '*** ERROR ***',,,Smg$M_Bold, Cuj$C_Center);
        Smg$Ring_Bell(Err, 3);
        Cuj$Put_String(Err, 'Unable to make changes in the data file', 2,,,Cuj$C_Center_Column);
        Cuj$Put_String(Err, 'Hit any key to exit', 3,,,Cuj$C_Center_Column);
        Smg$End_Pasteboard_Update(Scr);
        Smg$Read_Keystroke(Kb, Key);
        Smg$Delete_Virtual_Display(Err);
      END;
    Close(Fv, Error := Continue);
    Writeln(Cuj$Cursor_On);
    Smg$Delete_Pasteboard(Scr);
    IF Changes THEN
      Writeln('%', Image, '-S-CONFIG, configuration has been saved');
    Open(User_Fv, Info.Data_Directory+Users_Name, Unknown, Access_Method := Direct, Error := Continue);
    Open(Chan_Fv, Info.Data_Directory+Channel_Name, Unknown, Organization := Indexed, Access_Method := Keyed, Error := Continue);
    Open(Stat_Fv, Info.Data_Directory+Status_Name, Unknown, Organization := Indexed, Access_Method := Keyed, Error := Continue);
    Close(User_Fv, Error := Continue);
    Close(Chan_Fv, Error := Continue);
    Close(Stat_Fv, Error := Continue);
    Cuj$Set_Default_Protection(Prot);
  END; { Save_Info }

{-----------------------------------------------------------------------------}

BEGIN
  Make_Screen;
  Get_Info;
  Display_Info;
  Modify_Info;
  Save_Info;
END.
