{-----------------------------------------------------------------------------}
{                                                                             }
{                            Intercom Definitions                             }
{                                    v1.0                                     }
{                                 Written by                                  }
{                               Steven C. King                                }
{                            stuking@acs.eku.edu                              }
{                            sking@eagle.eku.edu                              }
{                                   (Cujo)                                    }
{                            Copyright 1993, 1994                             }
{                       Last revision: April 13, 1994                         }
{                                                                             }
{     This software is licensed for public domain and may be distributed pro- }
{ vided this notice remains intact with each copy distribution.  There is no  }
{ warranty on the performance of this software.  The author assumes no re-    }
{ sponsibility should any damages occur due to code alteration.  Therefore,   }
{ any such consideration of code modification should be reported to the orig- }
{ inal author.                                                                }
{                                                                             }
{       This file contains constants and data types used with INT_MAINT.PAS   }
{ and INTERCOM.PAS.  Some items can be changed to your desire, but take note  }
{ that the others should not be changed in order to receive top performance   }
{ from Intercom.  If changes have been made, you must delete the data(.DAT)   }
{ files created by INT_MAINT, recompile the maintenance and the Intercom pro- }
{ grams, and run them before they are used.  If there are any questions, com- }
{ ments, or suggestions, send e-mail to my Internet address(es).  Enjoy!      }
{                                                                             }
{ Modifications:                                                              }
{                                                                             }
{-----------------------------------------------------------------------------}

CONST
             (* Prefixes for Intercom messages - do not change *)
  Int$Ban             = '|*BAN*| - ';
  Int$Bitnet          = '|*BITNET*| - ';
  Int$Brkthru         = '|*BRKTHRU*| - ';
  Int$Broadcast       = '|*User_Broadcast*| - ';
  Int$Change          = '|*CHANGE*| - ';
  Int$Decnet          = '|*DECNET*| - ';
  Int$Error           = '|*ERROR*| - ';
  Int$Getop           = '|*GETOP*| - Operator request has been sent';
  Int$Ignore          = '|*IGNORE*| - ';
  Int$Info            = '|*INFO*| - ';
  Int$Invite          = '|*INVITE*| - ';
  Int$Mail            = '|*VMS_Mail*| - New message received from ';
  Int$Op              = '|*OP*| - ';
  Int$Script_Prefix   = '|*SCRIPT*| - ';
  Int$Shutdown        = '|*SHUTDOWN*| - Intercom has been shutdown by ';
  Int$Signoff         = '|*SIGNOFF*| - ';
  Int$Signon          = '|*SIGNON*| - ';
  Int$System          = '|*System*| - ';
  Int$Talk            = '|*TALK_Daemon*| - Invitation received from ';
  Int$Unban           = '|*UNBAN*| - ';
  Int$Unknown         = '|*Unknown_Broadcast*| - ';
  Int$Warning         = '|*WARNING*| - ';
  Int$Whois           = '|*WHOIS*| - ';

              (* Intercom messages sent via SEND - changeable *)
  Int$Join            = '*INTERCOM* - To join, type @';
  Int$User_Invite     = '*INTERCOM* - You have been invited to channel ';

                  (* DCL mailbox devices - do not change *)
  Int$In_Dcl_Mailbox  = 'INT$IN_DCL_MAILBOX';
  Int$Out_Dcl_Mailbox = 'INT$OUT_DCL_MAILBOX';

      (* User set logical names in LNM$PROCESS_TABLE - do not change *)
  Int$Channel         = 'INT$CHANNEL';
  Int$Data            = 'INT$DATA';
  Int$Lines           = 'INT$LINES';
  Int$Menu            = 'INT$MENU';
  Int$Nick            = 'INT$NICK';
  Int$Prompt          = 'INT$PROMPT';
  Int$Rendition       = 'INT$RENDITION';
  Int$Ring_Bell       = 'INT$RING_BELL';
  Int$Script          = 'INT$SCRIPT';
  Int$Scroll          = 'INT$SCROLL';
  Int$Status          = 'INT$STATUS';
  Int$Windows         = 'INT$WINDOWS';

               (* Data files used to store data - changeable *)
  Users_Name          = 'INT$USERS.DAT';
  Channel_Name        = 'INT$CHANNELS.DAT';
  Status_Name         = 'INT$STATS.DAT';
  Config_Name         = 'INT$CONFIGURE.DAT';

   (* Mailbox byte size flags - take extreme caution when changing these *)
  Int$Maxmsg          = 1000; (* Max message for Intercom mailbox    *)
  Int$Bufquo          = 4000; (* Buffer quota for Intercom mailbox   *)
  Int$In_Maxmsg       = 100;  (* Max message for DCL input mailbox   *)
  Int$In_Bufquo       = 500;  (* Buffer quota for DCL input mailbox  *)
  Int$Out_Maxmsg      = 200;  (* Max message for DCL output mailbox  *)
  Int$Out_Bufquo      = 200;  (* Buffer quota for DCL output mailbox *)

           (* Channel and/or message flags - do not change these *)
  Int$Public          = 1;  (* Public channel/message              *)
  Int$Private         = 2;  (* Private channel/message             *)
  Int$Operator        = 4;  (* Operator channel                    *)
  Int$Exclude         = 8;  (* Self-user will not receive messages *)
  Int$Global          = 16; (* Announcement message by operators   *)
  Int$Action          = 32; (* Action performed by a nickname      *)
  Int$Bypass          = 64; (* Bypass a nickname's ignore list     *)

               (* Flags to set the channel mode - changeable *)
             (* Maximum length is 4 characters - put in upcase *)
  Int$Public_Mode     = 'PUBL';
  Int$Private_Mode    = 'PRIV';
  Int$Operator_Mode   = 'OPER';

  Int$Dcl_Prefix      = 'DCL Command: '; (* Prefix string when echoing DCL *)
                                         (* commands - changeable - max    *)
                                         (* length is unspecified          *)

  Int$No_Mailbox      = 'MBX$EXIT'; (* Empty mailbox device - do not change *)

  Int$Prot_Dcl_Mask   = %b'1111111100001111'; (* (,RWLP,,) - do not change *)

  Int$Prot_Mask       = %b'0100111100001111'; (* (,RWLP,,RWL) - do not change *)

  Int$Terminator      = Chr(0); (* Message terminator - do not change *)

  Prompt_String       = 'Enter nickname: '; (* Prompt string - changeable *)

  Max_Commands        = 58; (* Number of Intercom commands - change only if *)
                            (* more commands are added                      *)

  Int$Invisible       = '(I)'; (* Flag to indicate a user is invisible on the *)
                               (* userlist - changeable - max length is 3     *)

  Int$Mailbox         = 'INT$MAILBOX'; (* Intercom message mailbox - do not *)
                                       (* change                            *)

  Int$Ctrl_Mask       = %b'00000010100001011000000000011110'; (* Control A,  *)
                                  (* B, C, D, O, P, W, and Y - do not change *)

  Prot_Mask           = %b'1100110001001100'; (* (RW,RWD,RW,RW) - changeable *)
                                              (* but needs W:RW access       *)

  Shutdown_Mask       = %b'1111111101001111'; (* (,RWD,,) - do not change *)

  Int$Keyword         = 'The interesting, radical keyword for Intercom v3.0';
                        (* If you change the keyword, make sure you recom- *)
                        (* pile Intercom and the maintenance program.  You *)
                        (* will also have to delete and recreate all the   *)
                        (* data files with the maintenance program.        *)

  Int$Command         = '/';  (* The character to represent the string as a  *)
                              (* command.  Take caution when changing this   *)
                              (* constant.  Only define to a character.      *)

  Int$Timeout_Wait    = 10;   (* Timeout period of accessing records in sec- *)
                              (* onds.  Changeable, but make it more than 5  *)
                              (* seconds.                                    *)

  Int$Spawn_Out       = '(spawning)'; (* User's nickname when spawning from  *)
                                      (* Intercom - changeable - do not use  *)
                                      (* leading or trailing spaces          *)

  Int$Spawn_Mailbox   = 'MBX$SPWN';  (* Mailbox name when spawning out - max *)
                                     (* length is 8 characters - take cau-   *)
                                     (* when changing this constant - do not *)
                                     (* use trailing or leading spaces       *)

  Int$No_Uic          = '[******]';  (* String to indicate a UIC does not    *)
                                     (* exist for a username - max length is *)
                                     (* 8 characters - changeable            *)

  Int$No_Login        = '<none>';  (* String to indicate a user has no login *)
                                   (* record.  This should only occur when a *)
                                   (* user is banned or has become an opera- *)
                                   (* when they haven't signed on yet - max  *)
                                   (* length is 20 characters - changeable   *)

  Int$No_Topic        = 'N/A'; (* String for an empty topic - 60 characters  *)
                               (* is the maximum length - changeable - no    *)
                               (* trailing or leading spaces                 *)

  Int$No_Chan_Owner   = 'N/A'; (* String indicating a non-existing channel   *)
                               (* owner - max length is 15 characters -      *)
                               (* changeable - no trailing or leading spaces *)

  Int$No_User_Owner   = 'N/A'; (* String indicating a non-existing username  *)
                               (* owner - max length is 32 characters -      *)
                               (* changeable - no trailing or leading spaces *)

  Int$Private_Channel = '|?|'; (* String to indicate a channel is private -  *)
                               (* max length is 10 characters - changeable - *)
                               (* do not put any spaces in the string!!      *)

  Int$Max_Signons     = 9999;  (* Maximum number of signons logged before it *)
                               (* is reset to 0 - do not change              *)

  Int$Null_Device     = 'MBX$NULL'; (* Null mailbox device sent with public   *)
                                    (* and announcing messages - maximum      *)
                                    (* length is 8 characters - do not change *)

                     (* Intercom commands - changeable *)
            (* Uppercase letters indicate command abbreviations *)
                (* Make sure that each command is unique!! *)
  Int$Announce        = Int$Command + 'ANnounce <message>   - Make an announcement';
  Int$Assign          = Int$Command + 'ASsign <user/nick>   - Assign a user or nickname';
  Int$Ban_User        = Int$Command + 'BAnuser <username>   - Ban a username';
  Int$Bell            = Int$Command + 'BEll                 - Toggle bell';
  Int$Brkthru_Command = Int$Command + 'BRkthru <nick> <msg> - Bypass a nickname''s ignore list';
  Int$Change_Channel  = Int$Command + 'CHannel <channel>    - Change to a channel';
  Int$Clear_Screen    = Int$Command + 'CLs                  - Clear the screen';
  Int$Deassign        = Int$Command + 'DEAssign <number>    - Deassign a user or nickname';
  Int$Delete_Record   = Int$Command + 'DELete <user>        - Delete/undelete a user''s signon record';
  Int$Dcl_Command     = Int$Command + 'DCl <command>        - Do a DCL command';
  Int$Echo_Dcl        = Int$Command + 'ECHODcl              - Toggle echoing of DCL commands';
  Int$Echo_Send       = Int$Command + 'ECHOSend             - Toggle echoing of SEND commands';
  Int$Echo_Messages   = Int$Command + 'ECHOPrivate          - Toggle echoing of private/queried messages';
  Int$Erase_Nick      = Int$Command + 'ERASENick <nick>     - Erase an ignored nickname';
  Int$Erase_User      = Int$Command + 'ERASEUser <user>     - Erase an ignored username';
  Int$Exit_Program    = Int$Command + 'EXit                 - Exit from Intercom';
  Int$Getop_Command   = Int$Command + 'Getop                - Get an Intercom operator';
  Int$Help            = Int$Command + 'HElp                 - Display this help screen';
  Int$Hide            = Int$Command + 'HIde [user]          - Hide a user''s signon record';
  Int$Hours           = Int$Command + 'HOurs                - Show Intercom operation hours';
  Int$Ignore_Nick     = Int$Command + 'IGNORENick <nick>    - Ignore a nickname';
  Int$Ignore_User     = Int$Command + 'IGNOREUser <user>    - Ignore a username';
  Int$Introduction    = Int$Command + 'INTroduction         - Display introduction message';
  Int$Invite_Nick     = Int$Command + 'INVITENick <nick>    - Invite a nickname';
  Int$Invite_User     = Int$Command + 'INVITEUser <user>    - Invite a username';
  Int$Limit           = Int$Command + 'LIMit <number>       - Set a channel limit of users';
  Int$List_Assigns    = Int$Command + 'LISTAssigns          - List user/nickname assignments';
  Int$List_Channels   = Int$Command + 'LISTChans            - List channels';
  Int$List_Nicks      = Int$Command + 'LISTNicks            - List ignored nicknames';
  Int$List_Ops        = Int$Command + 'LISTOps              - List Intercom operators';
  Int$List_Topics     = Int$Command + 'LISTTopics           - List channel topics';
  Int$List_Users      = Int$Command + 'LISTUsers            - List ignored users';
  Int$Lock_Topic      = Int$Command + 'LOcktopic            - Lock the channel topic';
  Int$Make_Op         = Int$Command + 'MAkeop <user>        - Make an Intercom operator';
  Int$Me              = Int$Command + 'ME <msg>             - Perform an action';
  Int$Mode            = Int$Command + 'MOde [flag]          - Set channel mode';
  Int$Nickname        = Int$Command + 'Nickname <nick>      - Change nickname';
  Int$Owner           = Int$Command + 'Owner                - Become the channel owner';
  Int$Private_Message = Int$Command + 'Private <nick> <msg> - Send a private message';
  Int$Query           = Int$Command + 'Query <nick>         - Query private messages';
  Int$Record          = Int$Command + 'RECord [user]        - Show a username record';
  Int$Redraw          = Int$Command + 'REDraw               - Redraw the screen';
  Int$Remove_Op       = Int$Command + 'REMoveop <user>      - Remove an Intercom operator';
  Int$Rendition_Set   = Int$Command + 'RENdition [rend]     - Set window rendition';
  Int$Script_File     = Int$Command + 'SCRIpt <file>        - Execute a script file';
  Int$Scroll_Toggle   = Int$Command + 'SCROll               - Toggle scroll mode';
  Int$Send            = Int$Command + 'SEnd <user> <msg>    - SEND to a username';
  Int$Shutdown_Cmd    = Int$Command + 'SHutdown             - Shutdown Intercom';
  Int$Send_Query      = Int$Command + 'SNdquery <user>      - Query SEND messages';
  Int$Spawn           = Int$Command + 'SPawn                - Spawn from Intercom';
  Int$Status_Command  = Int$Command + 'STatus               - Toggle status bar';
  Int$Time            = Int$Command + 'TIme                 - Show current time';
  Int$Topic_Set       = Int$Command + 'TOpic <topic>        - Set a channel topic';
  Int$Users           = Int$Command + 'USers [channel]      - Show Intercom users';
  Int$Unban_User      = Int$Command + 'UNbanuser <user>     - Unban a username';
  Int$Visibility      = Int$Command + 'Visibility           - Toggle visibility';
  Int$Whois_Command   = Int$Command + 'WHois <nick>         - Who owns the nickname';
  Int$Windows_Toggle  = Int$Command + 'WIndows              - Toggle windows';

{-----------------------------------------------------------------------------}

                    (* Do not change the type settings *)
TYPE
  Bit2_Type          = [Bit(2)] 0..3;
  Bit3_Type          = [Bit(3)] 0..7;
  Bit4_Type          = [Bit(4)] 0..15;
  Bit5_Type          = [Bit(5)] 0..31;
  Bit6_Type          = [Bit(6)] 0..63;
  Bit7_Type          = [Bit(7)] 0..127;
  Packed1000         = PACKED ARRAY [1..1000] OF Char;
  Varying1000        = VARYING [1000] OF Char;
  User_Record_Type   = RECORD
                         Nickname  : Cuj$Packed15;          (* User's Nickname       *)
                         Username  : Cuj$Varying12;         (* Username              *)
                         Uic       : Cuj$Varying10;         (* User's UIC            *)
                         Mailbox   : Cuj$Varying8;          (* User's mailbox        *)
                         Prefix    : Cuj$Varying10;         (* User's message prefix *)
                         Channel   : Cuj$Packed10;          (* User's channel        *)
                         Menu      : Cuj$Bit;               (* Menu use flag         *)
                         Windows   : Cuj$Bit;               (* Windows use flag      *)
                         Prompt    : Cuj$Bit;               (* Prompt use flag       *)
                         Invisible : Cuj$Bit;               (* Invisible user flag   *)
                         Lines     : Bit2_Type;             (* Number of input lines *)
                         Rendition : Bit5_Type;             (* Rendition for boxes   *)
                       END;
  Chan_Record_Type   = RECORD
                         Name  : [Key(0)] Cuj$Packed10; (* Channel name - case sensitive  *)
                         Owner : Cuj$Packed15;          (* Channel owner                  *)
                         Topic : Cuj$Varying60;         (* Channel topic                  *)
                         Users : Integer;               (* Number of users on the channel *)
                         Limit : Integer;               (* Max number of users allowed    *)
                         Flag  : Bit3_Type;             (* Channel flag                   *)
                         Lock  : Cuj$Bit;               (* Topic lock flag                *)
                       END;
  Stat_Record_Type   = RECORD
                         Username : [Key(0)] Cuj$Packed12; (* Username        *)
                         Unused   : [Key(1)] Cuj$Word;     (* Unused flag     *)
                         Uic      : Cuj$Varying8;          (* User's UIC      *)
                         Nickname : Cuj$Packed15;          (* User's nickname *)
                         Owner    : Cuj$Varying32;         (* Account owner   *)
                         Login    : Cuj$Varying20;         (* Last signon     *)
                         Date     : Cuj$Varying11;         (* New record date *)
                         Signons  : Integer;               (* Times used      *)
                         Banned   : Cuj$Bit;               (* Ban flag        *)
                         Operator : Cuj$Bit;               (* Operator flag   *)
                         Hidden   : Cuj$Bit;               (* Hidden flag     *)
                       END;
  Channel_Type       = RECORD
                         Low, High : Integer; (* Numeric channel range *)
                       END;
  Hours_Type         = PACKED ARRAY [1..7,0..23,1..4] OF Char; (* Operation hours *)
  Setup_Record_Type  = RECORD
                         Master_Operator    : Cuj$Varying12;   (* Master operator                     *)
                         Master_Uic         : Cuj$Varying8;    (* Master UIC - hidden record          *)
                         Data_Directory     : Cuj$Varying255;  (* Location of the data files          *)
                         Intro_Filename     : Cuj$Varying255;  (* Introduction data file              *)
                         Max_Users          : Integer;         (* Maximum number of signons           *)
                         Current_Signons    : Integer;         (* Current number of users signed in   *)
                         Max_Operators      : Integer;         (* Maximum number of operators         *)
                         Max_User_Ignore    : Integer;         (* Maximum number of ignored users     *)
                         Max_Nick_Ignore    : Integer;         (* Maximum number of ignored nicks     *)
                         Max_Per_Channel    : Integer;         (* Maximum number of users per channel *)
                         Max_Assigns        : Integer;         (* Maximum number of assigns           *)
                         Public_Channels    : Channel_Type;    (* Range of public channels            *)
                         Private_Channels   : Channel_Type;    (* Range of private channels           *)
                         Operator_Channels  : Channel_Type;    (* Range of operator channels          *)
                         Topic_Wait         : Integer;         (* Topic change wait in minutes        *)
                         Nickname_Wait      : Integer;         (* Nickname change wait in minutes     *)
                         Shutdown           : Cuj$Bit;         (* Intercom shutdown flag              *)
                         Alphanumeric       : Cuj$Bit;         (* Can channel #s be alphanumeric?     *)
                         Allow_Announce     : Cuj$Bit;         (* Can ops make an announcement?       *)
                         Allow_Op_Access    : Cuj$Bit;         (* Can ops make/remove operators?      *)
                         Allow_Spawn        : Cuj$Bit;         (* Can normal users spawn out?         *)
                         Allow_Send         : Cuj$Bit;         (* Do users have access to SEND?       *)
                         Hours_In_Effect    : Cuj$Bit;         (* Are the hours in effect?            *)
                         Operation_Hours    : Hours_Type;      (* Intercom operation hours            *)
                       END;
  Node_Type          = ^Userlist_Type;
  Userlist_Type      = RECORD
                         Channel   : Cuj$Packed10;   (* Channel name   *)
                         Nickname  : Cuj$Packed15;   (* Nickname       *)
                         Username  : Cuj$Varying12;  (* Username       *)
                         Operator  : Char;           (* Operator flag  *)
                         Invisible : Cuj$Packed3;    (* Invisible flag *)
                         Ptr       : Node_Type;      (* Next node      *)
                       END;
  Node2_Type         = ^Assign_Type;
  Assign_Type        = RECORD
                         User : Cuj$Varying22;
                         Ptr  : Node2_Type;
                       END;
